Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_deallocation.cpp	(revision 88)
@@ -23,4 +23,6 @@
     log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
 
+    if (usage_is_set(_usage,USE_VHDL))
+      {
 //#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
     delete    in_CLOCK ;
@@ -95,20 +97,20 @@
     delete []  in_INSERT_ROB_SPR_STATUS_ACK       ;
 
-    // ~~~~~[ Interface "retire_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-    delete []  in_RETIRE_ROB_VAL                      ;
-    delete [] out_RETIRE_ROB_ACK                      ;
-    delete []  in_RETIRE_ROB_RD_OLD_USE               ;
-    delete []  in_RETIRE_ROB_RD_NEW_USE               ;
-    delete []  in_RETIRE_ROB_RE_OLD_USE               ;
-    delete []  in_RETIRE_ROB_RE_NEW_USE               ;
-    delete [] out_RETIRE_ROB_GPR_STATUS_OLD_VAL       ;
-    delete [] out_RETIRE_ROB_GPR_STATUS_NEW_VAL       ;
-    delete []  in_RETIRE_ROB_GPR_STATUS_OLD_ACK       ;
-    delete []  in_RETIRE_ROB_GPR_STATUS_NEW_ACK       ;
-    delete [] out_RETIRE_ROB_SPR_STATUS_OLD_VAL       ;
-    delete [] out_RETIRE_ROB_SPR_STATUS_NEW_VAL       ;
-    delete []  in_RETIRE_ROB_SPR_STATUS_OLD_ACK       ;
-    delete []  in_RETIRE_ROB_SPR_STATUS_NEW_ACK       ;
-
+//     // ~~~~~[ Interface "retire_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+//     delete []  in_RETIRE_ROB_VAL                      ;
+//     delete [] out_RETIRE_ROB_ACK                      ;
+//     delete []  in_RETIRE_ROB_RD_OLD_USE               ;
+//     delete []  in_RETIRE_ROB_RD_NEW_USE               ;
+//     delete []  in_RETIRE_ROB_RE_OLD_USE               ;
+//     delete []  in_RETIRE_ROB_RE_NEW_USE               ;
+//     delete [] out_RETIRE_ROB_GPR_STATUS_OLD_VAL       ;
+//     delete [] out_RETIRE_ROB_GPR_STATUS_NEW_VAL       ;
+//     delete []  in_RETIRE_ROB_GPR_STATUS_OLD_ACK       ;
+//     delete []  in_RETIRE_ROB_GPR_STATUS_NEW_ACK       ;
+//     delete [] out_RETIRE_ROB_SPR_STATUS_OLD_VAL       ;
+//     delete [] out_RETIRE_ROB_SPR_STATUS_NEW_VAL       ;
+//     delete []  in_RETIRE_ROB_SPR_STATUS_OLD_ACK       ;
+//     delete []  in_RETIRE_ROB_SPR_STATUS_NEW_ACK       ;
+      }
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_end_cycle.cpp	(revision 88)
@@ -24,5 +24,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -30,5 +31,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read.cpp	(revision 88)
@@ -23,19 +23,28 @@
   void Register_unit_Glue::genMealy_gpr_read (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+// 	  PORT_WRITE(out_GPR_READ_ACK      [j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_READ_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t registerfile_ack = PORT_READ(in_GPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
-	Tcontrol_t status_ack       = PORT_READ(in_GPR_READ_STATUS_ACK       [ooo_engine_id][j]);
-
-	// multiplexor
-	PORT_WRITE(out_GPR_READ_ACK      [j], registerfile_ack and status_ack);
-	PORT_WRITE(out_GPR_READ_DATA     [j], PORT_READ(in_GPR_READ_REGISTERFILE_DATA[ooo_engine_id][j]));
-	PORT_WRITE(out_GPR_READ_DATA_VAL [j], PORT_READ(in_GPR_READ_STATUS_DATA_VAL  [ooo_engine_id][j]));
+	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+	  {
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_READ_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t registerfile_ack = PORT_READ(in_GPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
+	    Tcontrol_t status_ack       = PORT_READ(in_GPR_READ_STATUS_ACK       [ooo_engine_id][j]);
+	    
+	    // multiplexor
+	    PORT_WRITE(out_GPR_READ_ACK      [j], registerfile_ack and status_ack);
+	    PORT_WRITE(out_GPR_READ_DATA     [j], PORT_READ(in_GPR_READ_REGISTERFILE_DATA[ooo_engine_id][j]));
+	    PORT_WRITE(out_GPR_READ_DATA_VAL [j], PORT_READ(in_GPR_READ_STATUS_DATA_VAL  [ooo_engine_id][j]));
+	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read_registerfile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read_registerfile.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read_registerfile.cpp	(revision 88)
@@ -23,22 +23,32 @@
   void Register_unit_Glue::genMealy_gpr_read_registerfile (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_GPR_READ_REGISTERFILE_VAL [i][j],0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_READ_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t val              = PORT_READ(in_GPR_READ_VAL [j]);
-	Tcontrol_t status_ack       = PORT_READ(in_GPR_READ_STATUS_ACK       [ooo_engine_id][j]);
-    
-	Tcontrol_t registerfile_val = val and status_ack;
-
-	for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
 	  {
-	    Tcontrol_t id = (i == ooo_engine_id)?1:0;
-	    PORT_WRITE(out_GPR_READ_REGISTERFILE_VAL [i][j], (id and registerfile_val));
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_READ_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t val              = PORT_READ(in_GPR_READ_VAL [j]);
+	    Tcontrol_t status_ack       = PORT_READ(in_GPR_READ_STATUS_ACK       [ooo_engine_id][j]);
+	    
+	    Tcontrol_t registerfile_val = val and status_ack;
+	    
+	    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	      {
+		Tcontrol_t id = (i == ooo_engine_id)?1:0;
+		PORT_WRITE(out_GPR_READ_REGISTERFILE_VAL [i][j], (id and registerfile_val));
+	      }
 	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read_status.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read_status.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_read_status.cpp	(revision 88)
@@ -23,22 +23,32 @@
   void Register_unit_Glue::genMealy_gpr_read_status (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_GPR_READ_STATUS_VAL       [i][j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_READ_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t val              = PORT_READ(in_GPR_READ_VAL [j]);
-	Tcontrol_t registerfile_ack = PORT_READ(in_GPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
-    
-	Tcontrol_t status_val       = val and registerfile_ack;
-
-	for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	for (uint32_t j=0; j<_param->_nb_gpr_read; j++)
 	  {
-	    Tcontrol_t id = (i == ooo_engine_id)?1:0;
-	    PORT_WRITE(out_GPR_READ_STATUS_VAL       [i][j], (id and status_val));
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_READ_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t val              = PORT_READ(in_GPR_READ_VAL [j]);
+	    Tcontrol_t registerfile_ack = PORT_READ(in_GPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
+	    
+	    Tcontrol_t status_val       = val and registerfile_ack;
+	    
+	    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	      {
+		Tcontrol_t id = (i == ooo_engine_id)?1:0;
+		PORT_WRITE(out_GPR_READ_STATUS_VAL       [i][j], (id and status_val));
+	      }
 	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_registerfile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_registerfile.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_registerfile.cpp	(revision 88)
@@ -23,21 +23,31 @@
   void Register_unit_Glue::genMealy_gpr_write_registerfile (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_GPR_WRITE_REGISTERFILE_VAL [i][j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t val              = PORT_READ(in_GPR_WRITE_VAL [j]);
-	Tcontrol_t status_ack       = PORT_READ(in_GPR_WRITE_STATUS_ACK       [ooo_engine_id][j]);
-	Tcontrol_t registerfile_val = val and status_ack;
-	
-	for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	  {
-	    Tcontrol_t id = (i == ooo_engine_id)?1:0;
-	    PORT_WRITE(out_GPR_WRITE_REGISTERFILE_VAL [i][j], (id and registerfile_val));
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t val              = PORT_READ(in_GPR_WRITE_VAL [j]);
+	    Tcontrol_t status_ack       = PORT_READ(in_GPR_WRITE_STATUS_ACK       [ooo_engine_id][j]);
+	    Tcontrol_t registerfile_val = val and status_ack;
+	    
+	    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	      {
+		Tcontrol_t id = (i == ooo_engine_id)?1:0;
+		PORT_WRITE(out_GPR_WRITE_REGISTERFILE_VAL [i][j], (id and registerfile_val));
+	      }
 	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_write.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_write.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_write.cpp	(revision 88)
@@ -23,17 +23,26 @@
   void Register_unit_Glue::genMealy_gpr_write (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
-
-    for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_GPR_WRITE_ACK [j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t registerfile_ack = PORT_READ(in_GPR_WRITE_REGISTERFILE_ACK [ooo_engine_id][j]);
-	Tcontrol_t status_ack       = PORT_READ(in_GPR_WRITE_STATUS_ACK       [ooo_engine_id][j]);
-
-	// multiplexor
-	PORT_WRITE(out_GPR_WRITE_ACK [j],registerfile_ack and status_ack);
+	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+	  {
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t registerfile_ack = PORT_READ(in_GPR_WRITE_REGISTERFILE_ACK [ooo_engine_id][j]);
+	    Tcontrol_t status_ack       = PORT_READ(in_GPR_WRITE_STATUS_ACK       [ooo_engine_id][j]);
+	    
+	    // multiplexor
+	    PORT_WRITE(out_GPR_WRITE_ACK [j],registerfile_ack and status_ack);
+	  }
       }
-
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_write_status.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_write_status.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_gpr_write_status.cpp	(revision 88)
@@ -23,21 +23,31 @@
   void Register_unit_Glue::genMealy_gpr_write_status (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_GPR_WRITE_STATUS_VAL       [i][j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t val              = PORT_READ(in_GPR_WRITE_VAL [j]);
-	Tcontrol_t registerfile_ack = PORT_READ(in_GPR_WRITE_REGISTERFILE_ACK [ooo_engine_id][j]);
-	Tcontrol_t status_val       = val and registerfile_ack;
-	
-	for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	for (uint32_t j=0; j<_param->_nb_gpr_write; j++)
 	  {
-	    Tcontrol_t id = (i == ooo_engine_id)?1:0;
-	    PORT_WRITE(out_GPR_WRITE_STATUS_VAL       [i][j], (id and status_val));
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_GPR_WRITE_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t val              = PORT_READ(in_GPR_WRITE_VAL [j]);
+	    Tcontrol_t registerfile_ack = PORT_READ(in_GPR_WRITE_REGISTERFILE_ACK [ooo_engine_id][j]);
+	    Tcontrol_t status_val       = val and registerfile_ack;
+	    
+	    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	      {
+		Tcontrol_t id = (i == ooo_engine_id)?1:0;
+		PORT_WRITE(out_GPR_WRITE_STATUS_VAL       [i][j], (id and status_val));
+	      }
 	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_insert.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_insert.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_insert.cpp	(revision 88)
@@ -23,25 +23,42 @@
   void Register_unit_Glue::genMealy_insert (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-      {
-	uint32_t x=_param->_nb_inst_insert_rob [i];
+      for (uint32_t j=0; j<_param->_nb_inst_insert_rob [i]; j++)
+        {
+          Tcontrol_t val            = PORT_READ(in_INSERT_ROB_VAL [i][j]);
+          Tcontrol_t gpr_use        = PORT_READ(in_INSERT_ROB_RD_USE [i][j]);
+          Tcontrol_t spr_use        = PORT_READ(in_INSERT_ROB_RE_USE [i][j]);
+          Tcontrol_t gpr_status_ack = PORT_READ(in_INSERT_ROB_GPR_STATUS_ACK [i][j]);
+          Tcontrol_t spr_status_ack = PORT_READ(in_INSERT_ROB_SPR_STATUS_ACK [i][j]);
+	  
+          Tcontrol_t ack            = (gpr_status_ack and 
+                                       spr_status_ack);	    
+          Tcontrol_t gpr_status_val = (val     and 
+                                       gpr_use and 
+                                       spr_status_ack);
+          Tcontrol_t spr_status_val = (val     and 
+                                       spr_use and
+                                       gpr_status_ack);
 
-	for (uint32_t j=0; j<x; j++)
-	  {
-	    Tcontrol_t val = PORT_READ(in_INSERT_ROB_VAL [i][j]);
-	    Tcontrol_t gpr_use = PORT_READ(in_INSERT_ROB_RD_USE [i][j]);
-	    Tcontrol_t spr_use = PORT_READ(in_INSERT_ROB_RE_USE [i][j]);
-	    Tcontrol_t gpr_ack = PORT_READ(in_INSERT_ROB_GPR_STATUS_ACK [i][j]);
-	    Tcontrol_t spr_ack = PORT_READ(in_INSERT_ROB_SPR_STATUS_ACK [i][j]);
-	    
-	    PORT_WRITE(out_INSERT_ROB_ACK [i][j], gpr_ack and spr_ack);	    
-	    PORT_WRITE(out_INSERT_ROB_GPR_STATUS_VAL [i][j], val and gpr_use and spr_ack);
-	    PORT_WRITE(out_INSERT_ROB_SPR_STATUS_VAL [i][j], val and spr_use and gpr_ack);
-	  }
-      }
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"  * insert_rob [%d][%d]",i,j);
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * val            (r) : %d",val           );
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * ack            (w) : %d",ack           );
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * gpr_use (rd)   (r) : %d",gpr_use       );
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * gpr_status_val (w) : %d",gpr_status_val);
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * gpr_status_ack (r) : %d",gpr_status_ack);
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * spr_use (re)   (r) : %d",spr_use       );
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * spr_status_val (w) : %d",spr_status_val);
+          log_printf(TRACE,OOO_Engine_Glue,FUNCTION,"    * spr_status_ack (r) : %d",spr_status_ack);
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+          PORT_WRITE(out_INSERT_ROB_ACK            [i][j], ack           );
+          PORT_WRITE(out_INSERT_ROB_GPR_STATUS_VAL [i][j], gpr_status_val);
+          PORT_WRITE(out_INSERT_ROB_SPR_STATUS_VAL [i][j], spr_status_val);
+
+        }
+
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_retire.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_retire.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_retire.cpp	(revision 88)
@@ -8,4 +8,5 @@
  */
 
+/*
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/include/Register_unit_Glue.h"
 
@@ -23,5 +24,6 @@
   void Register_unit_Glue::genMealy_retire (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
     for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
@@ -57,5 +59,5 @@
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
@@ -68,4 +70,5 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
+*/
 #endif
 //#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read.cpp	(revision 88)
@@ -23,19 +23,28 @@
   void Register_unit_Glue::genMealy_spr_read (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+// 	  PORT_WRITE(out_SPR_READ_ACK      [j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_SPR_READ_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t registerfile_ack = PORT_READ(in_SPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
-	Tcontrol_t status_ack       = PORT_READ(in_SPR_READ_STATUS_ACK       [ooo_engine_id][j]);
-
-	// multiplexor
-	PORT_WRITE(out_SPR_READ_ACK      [j], registerfile_ack and status_ack);
-	PORT_WRITE(out_SPR_READ_DATA     [j], PORT_READ(in_SPR_READ_REGISTERFILE_DATA[ooo_engine_id][j]));
-	PORT_WRITE(out_SPR_READ_DATA_VAL [j], PORT_READ(in_SPR_READ_STATUS_DATA_VAL  [ooo_engine_id][j]));
+	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+	  {
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_SPR_READ_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t registerfile_ack = PORT_READ(in_SPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
+	    Tcontrol_t status_ack       = PORT_READ(in_SPR_READ_STATUS_ACK       [ooo_engine_id][j]);
+	    
+	    // multiplexor
+	    PORT_WRITE(out_SPR_READ_ACK      [j], registerfile_ack and status_ack);
+	    PORT_WRITE(out_SPR_READ_DATA     [j], PORT_READ(in_SPR_READ_REGISTERFILE_DATA[ooo_engine_id][j]));
+	    PORT_WRITE(out_SPR_READ_DATA_VAL [j], PORT_READ(in_SPR_READ_STATUS_DATA_VAL  [ooo_engine_id][j]));
+	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_registerfile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_registerfile.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_registerfile.cpp	(revision 88)
@@ -23,22 +23,31 @@
   void Register_unit_Glue::genMealy_spr_read_registerfile (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_SPR_READ_REGISTERFILE_VAL [i][j],0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_SPR_READ_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t val              = PORT_READ(in_SPR_READ_VAL [j]);
-	Tcontrol_t status_ack       = PORT_READ(in_SPR_READ_STATUS_ACK       [ooo_engine_id][j]);
-    
-	Tcontrol_t registerfile_val = val and status_ack;
-
-	for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
 	  {
-	    Tcontrol_t id = (i == ooo_engine_id)?1:0;
-	    PORT_WRITE(out_SPR_READ_REGISTERFILE_VAL [i][j], (id and registerfile_val));
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_SPR_READ_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t val              = PORT_READ(in_SPR_READ_VAL [j]);
+	    
+	    Tcontrol_t registerfile_val = val and PORT_READ(in_SPR_READ_STATUS_ACK [ooo_engine_id][j]);
+	    
+	    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	      {
+		Tcontrol_t id = (i == ooo_engine_id)?1:0;
+		PORT_WRITE(out_SPR_READ_REGISTERFILE_VAL [i][j], (id and registerfile_val));
+	      }
 	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_status.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_status.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_status.cpp	(revision 88)
@@ -23,22 +23,31 @@
   void Register_unit_Glue::genMealy_spr_read_status (void)
   {
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"Begin");
+    log_begin(Register_unit_Glue,FUNCTION);
+    log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-    for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+//     if (not PORT_READ(in_NRESET))
+//       {
+// 	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	    PORT_WRITE(out_SPR_READ_STATUS_VAL       [i][j], 0);
+//       }
+//     else
       {
-	Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_SPR_READ_OOO_ENGINE_ID[j]):0;
-	Tcontrol_t val              = PORT_READ(in_SPR_READ_VAL [j]);
-	Tcontrol_t registerfile_ack = PORT_READ(in_SPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
-    
-	Tcontrol_t status_val       = val and registerfile_ack;
-
-	for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
 	  {
-	    Tcontrol_t id = (i == ooo_engine_id)?1:0;
-	    PORT_WRITE(out_SPR_READ_STATUS_VAL       [i][j], (id and status_val));
+	    Tcontext_t ooo_engine_id    = (_param->_have_port_ooo_engine_id == true)?PORT_READ(in_SPR_READ_OOO_ENGINE_ID[j]):0;
+	    Tcontrol_t val              = PORT_READ(in_SPR_READ_VAL [j]);
+	    
+	    Tcontrol_t status_val       = val and PORT_READ(in_SPR_READ_REGISTERFILE_ACK [ooo_engine_id][j]);
+	    
+	    for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	      {
+		Tcontrol_t id = (i == ooo_engine_id)?1:0;
+		PORT_WRITE(out_SPR_READ_STATUS_VAL       [i][j], (id and status_val));
+	      }
 	  }
       }
 
-    log_printf(FUNC,Register_unit_Glue,FUNCTION,"End");
+    log_end(Register_unit_Glue,FUNCTION);
   };
 
